--Start loop
function start_loop()
	screen.clear(color.new(255,255,255))
	controls.read()
end
--end loop
function end_loop()
	screen.flip()
	screen.waitvblankstart()
end
--move
function move_left()
	if (rotation_z*math.pi)>(maximum_rotation_z*math.pi)*-1 then
		rotation_z=rotation_z-(0.01*math.pi)
	end
	if position_x>minimum_position_x then
		position_x=position_x-2
	end
end

function move_right()
	if (rotation_z*math.pi)<(maximum_rotation_z*math.pi) then
		rotation_z=rotation_z+(0.01*math.pi)
	end
	if position_x<maximum_position_x then
		position_x=position_x+2
	end
end

function down_depth()
	if current_depth<3 then
		current_depth=current_depth+1
	end
end

function up_depth()
	if current_depth>1 then
		current_depth=current_depth-1
	end
end

function depth_correction()
	if position_z<depth_level[current_depth] then
		position_z=position_z+2
	end
	if position_z>depth_level[current_depth] then
		position_z=position_z-2
	end
	if current_depth==3 and position_y<-9 then
		position_y=position_y+1
	end
	if current_depth~=3 and position_y>-30 then
		position_y=position_y-1
	end
	if current_depth==3 and position_x<-26 then
		position_x=position_x+2
	end
	if current_depth==3 and position_x>26 then
		position_x=position_x-2
	end
	if current_depth==2 and position_x<-58 then
		position_x=position_x+2
	end
	if current_depth==2 and position_x>58 then
		position_x=position_x-2
	end
	if current_depth==1 and position_x<-112 then
		position_x=position_x+2
	end
	if current_depth==1 and position_x>112 then
		position_x=position_x-2
	end
end
function move_none()
	if (rotation_z*math.pi)>(0.01*math.pi) then
		rotation_z=rotation_z-(0.01*math.pi)
	end
	if (rotation_z*math.pi)<(0.01*math.pi)*-1 then
		rotation_z=rotation_z+(0.01*math.pi)
	end
end

function loop_bots()
	for a=1,#enemy do
		if enemy[a].y<-200 then
			enemy[a].y=math.random(100,300)
			enemy[a].x=math.random(-58,58)
			enemy[a].depth=math.random(1,3)
		end
	end
end
function move_bots()
	for a=1,6 do
		enemy[a].y=enemy[a].y-(1-current_engine/100)
	end
	for a=7,10 do
		enemy[a].y=enemy[a].y-3
	end
	for a=7,10 do
		if enemy[a].x>position_x then
			enemy[a].x=enemy[a].x-1
			if enemy[a].rotation<maximum_rotation_z then
				enemy[a].rotation=enemy[a].rotation+0.1
			end
		end
		if enemy[a].x<position_x then
			enemy[a].x=enemy[a].x+1
			if enemy[a].rotation>(maximum_rotation_z*-1) then
				enemy[a].rotation=enemy[a].rotation-0.1
			end
		end
	end
end
function shoot()
	if current_bullet==5 then
		current_bullet=1
	else
		current_bullet=current_bullet+1
	end
	bullet[current_bullet].x=position_x
	bullet[current_bullet].y=position_y
	bullet[current_bullet].depth=current_depth
	bullet[current_bullet].x=bullet[current_bullet].x
	bullet[current_bullet].y=bullet[current_bullet].y
	bullet[current_bullet].depth=bullet[current_bullet].depth
end
function move_laser()
	for a=1,5 do
		if bullet[a].y<500 and bullet[a].y>-800 then
			bullet[a].y=bullet[a].y+5
		else
			bullet[a].y=-900
		end
	end
end
function check_collision(obj1,obj2)
	 if (obj1.x + 7 > obj2.x-6) and (obj1.x-7 < obj2.x + 7) and (obj1.y + 20 > obj2.y-6) and (obj1.y < obj2.y + 6) and (obj1.depth==obj2.depth) then
		return true
	end
end
function check_collision_2(obj2)
	 if (position_x + 6 > obj2.x-6) and (position_x-6 < obj2.x + 6) and (position_y + 6 > obj2.y-6) and (position_y -6< obj2.y + 6) and (current_depth==obj2.depth) then
		return true
	end
end
function check_collision_3(obj2)
	 if (position_x + 6 > obj2.x-10) and (position_x-6 < obj2.x + 10) and (position_y + 6 > obj2.y-10) and (position_y -6< obj2.y + 10) and (current_depth==obj2.depth) then
		return true
	end
end
function check_collision_4(obj1,obj2)
	 if (obj1.x + 10 > obj2.x-6) and (obj1.x-10 < obj2.x + 7) and (obj1.y + 10 > obj2.y-6) and (obj1.y-10 < obj2.y + 6) then
		return true
	end
end
function state_play()
	time_adder=time_adder+1
	if time_adder>20 then
		current_time=current_time+1
		time_adder=0
		score=score+1
	end
	screen.print(0,10,"SURVIVAL TIME:"..current_time.."       SCORE:"..score,color.new(0,255,0))
	
	if controls.left() then
		move_left()
	end
	if controls.right() then
		move_right()
	end
	if not controls.right() then
		if not controls.left() then
			move_none()
		end
	end
	if not controls.left() then
		if not controls.right() then
			move_none()
		end
	end
	if controls.press("up") then
		up_depth()
	end
	if controls.press("down") then
		down_depth()
	end
	if machine_gun==false then
		if controls.press("cross") or controls.press("r") then
			shoot()
		end
	else
		if controls.cross() then
			shoot()
		end
	end
	move_laser()
	depth_correction()
	
	loop_bots()
	move_bots()

	space_ship_object:position(position_x,position_y,position_z)
	space_ship_object:rotation(1.5,rotation_y,rotation_z)
	space_ship_object:blit()
	loop_asteroids()
	
	for a=1,10 do
		if enemy[a].x>28 and enemy[a].depth==3 then
			enemy[a].x=enemy[a].x-2
		end
		if enemy[a].x<-28 and enemy[a].depth==3 then
			enemy[a].x=enemy[a].x+2
		end
		enemy[a].model:position(enemy[a].x,enemy[a].y,depth_level[enemy[a].depth])
		enemy[a].model:rotation(1.5,3.2,enemy[a].rotation)
		enemy[a].model:blit()
	end
	for a=1,5 do
		bullet[a].model:position(bullet[a].x,bullet[a].y,depth_level[bullet[a].depth])
		bullet[a].model:rotation(2,0,0)
		bullet[a].model:blit()
	end
	for a=1,5 do
		for b=1,10 do
			if check_collision(bullet[a],enemy[b]) then
				if bullet[a].depth==1 then
					score=score+10
				end
				if bullet[a].depth==2 then
					score=score+25
				end
				if bullet[a].depth==1 then
					score=score+50
				end
				if current_piece<#pieces then
					current_piece=current_piece+1
				else
					current_piece=1
				end
				pieces[current_piece].x=enemy[b].x
				pieces[current_piece].y=enemy[b].y
				pieces[current_piece].depth=enemy[b].depth
				pieces[current_piece].rotation=0
				pieces[current_piece].x=pieces[current_piece].x
				pieces[current_piece].y=pieces[current_piece].y
				pieces[current_piece].depth=pieces[current_piece].depth
				
				enemy[b].x=math.random(-200,200)
				enemy[b].y=math.random(200,400)
				enemy[b].depth=math.random(1,3)
				bullet[a].y=-900
			end
		end
	end
	if current_time>shop_visit_number*200 then
		state="shop"
		if machine_gun==true then
			machine_gun=false
		end
		shop_visit_number=shop_visit_number+1
	end
	for a=1,4 do
		asteroid[a].model:position(asteroid[a].x,asteroid[a].y,depth_level[asteroid[a].depth])
		asteroid[a].model:rotation(asteroid_spin,asteroid_spin,asteroid_spin)
		asteroid[a].model:blit()
	end
	for a=1,10 do
		if check_collision_2(enemy[a]) then
			health=health-10
			enemy[a].x=math.random(-58,58)
			enemy[a].y=math.random(300,400)
			enemy[a].depth=math.random(1,3)
		end
	end
	for a=1,5 do
		if pieces[a].x<600 then
			pieces[a].x=pieces[a].x+move_rate_x
			pieces[a].y=pieces[a].y+move_rate_y
			pieces[a].rotation=pieces[a].rotation+spin_rate
			pieces[a].model:position(pieces[a].x,pieces[a].y,depth_level[pieces[a].depth])
			pieces[a].model:rotation(1.5,3.2+pieces[a].rotation,0)
			pieces[a].model:blit()
		end
	end
	
	screen.print(10,32,"Health: "..health,color.new(255,0,0))
	if controls.press("l") then
		if ammo>0 then
			ammo=ammo-1
			mega_bullet[current_mega_bullet].x=position_x
			mega_bullet[current_mega_bullet].y=position_y
			mega_bullet[current_mega_bullet].depth=current_depth
			mega_bullet[current_mega_bullet].x=mega_bullet[current_mega_bullet].x
			mega_bullet[current_mega_bullet].y=mega_bullet[current_mega_bullet].y
			mega_bullet[current_mega_bullet].depth=mega_bullet[current_mega_bullet].depth
			if current_mega_bullet>4 then
				current_mega_bullet=1
			else
				current_mega_bullet=current_mega_bullet+1
			end
		end
	end
	for a=1,5 do
		mega_bullet[a].model:position(mega_bullet[a].x,mega_bullet[a].y,depth_level[mega_bullet[a].depth])
		mega_bullet[a].model:blit()
		mega_bullet[a].y=mega_bullet[a].y+2
		for b=1,10 do
			if check_collision_4(mega_bullet[a],enemy[b]) then
				pieces[current_piece].x=enemy[b].x
				pieces[current_piece].y=enemy[b].y
				pieces[current_piece].depth=enemy[b].depth
				pieces[current_piece].rotation=0
				pieces[current_piece].x=pieces[current_piece].x
				pieces[current_piece].y=pieces[current_piece].y
				pieces[current_piece].depth=pieces[current_piece].depth
				
				enemy[b].x=math.random(-200,200)
				enemy[b].y=math.random(200,400)
				enemy[b].depth=math.random(1,3)
			end
		end
	end
	if health<1 then
		state="dead"
	end
	screen.print(10,250,"Current Mega Bullet Ammo: "..ammo,color.new(0,255,0))
end
function state_shop()
	if select==1 then
		screen.print(20,10,"Buy 5 Mega Bullets for 2000$$ ",color.new(0,255,0))
		screen.print(10,40,"Buy temporary string gun for 10000$$",color.new(0,255,0))
		screen.print(10,70,"Upgrade engines for " .. current_engine*100 .. "  Current upgrade: "..current_engine,color.new(0,255,0))
		screen.print(10,100,"Continue",color.new(0,255,0))
	elseif select==2 then
		screen.print(10,10,"Buy 5 Mega Bullets for 2000$$ ",color.new(0,255,0))
		screen.print(20,40,"Buy temporary string gun for 10000$$",color.new(0,255,0))
		screen.print(10,70,"Upgrade engines for " .. current_engine*100 .. "  Current upgrade: "..current_engine,color.new(0,255,0))
		screen.print(10,100,"Continue",color.new(0,255,0))
	elseif select==3 then
		screen.print(10,10,"Buy 5 Mega Bullets for 2000$$ ",color.new(0,255,0))
		screen.print(10,40,"Buy temporary strimg gun for 10000$$",color.new(0,255,0))
		screen.print(20,70,"Upgrade engines for " .. current_engine*100 .. "  Current upgrade: "..current_engine,color.new(0,255,0))
		screen.print(10,100,"Continue",color.new(0,255,0))
	elseif select==4 then
		screen.print(10,10,"Buy 5 Mega Bullets for 2000$$ ",color.new(0,255,0))
		screen.print(10,40,"Buy temporary string gun for 10000$$",color.new(0,255,0))
		screen.print(10,70,"Upgrade engines for " .. current_engine*100 .. "  Current upgrade: "..current_engine,color.new(0,255,0))
		screen.print(20,100,"Continue",color.new(0,255,0))
	end
	if controls.press("up") and select>1 then
		select=select-1
	end
	if controls.press("down") and select<4 then
		select=select+1
	end
	if controls.press("cross") and select==4 then
		state="play"
	end
	if controls.press("cross") and select==1 then
		if score>2000 then
			score=score-2000
			ammo=ammo+5
		end
	end
	if controls.press("cross") and select==2 then
		if score>10000 then
			score=score-10000
			machine_gun=true
		end
	end
	if controls.press("cross") and select==3 then
		if score>current_engine*100 then
			current_engine=current_engine+1
			score=score-current_engine*100
		end
	end
	screen.print(240,250,"$$ "..score,color.new(0,0,255))
end

function loop_asteroids()
	for a=1,4 do
		if asteroid[a].y<-500 then
			asteroid[a].y=math.random(400,600)
			asteroid[a].x=math.random(-400,400)
			asteroid[a].depth=math.random(1,3)
		end
		asteroid[a].y=asteroid[a].y-1
	end
end